/**
  ******************************************************************************
  * @file    main.c
  * @author  MCD Application Team
  * @version V0.5
  * @date    17/05/2010
  * @brief   Main program body
	* This release is made for HW board revB with silicon STM8L152 revB
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
  */

// Includes ------------------------------------------------------------------
#include "stm8l15x.h"
#include "stm8l1526_glass_lcd.h"
#include "icc_measure.h"
#include "LPdemo_functions.h"
#include <math.h>

  // * @addtogroup LCD_Example1
// Private typedef -----------------------------------------------------------

// Private define ------------------------------------------------------------
// Private macro -------------------------------------------------------------
// Private variables ---------------------------------------------------------
bool IDD_bool = FALSE;
bool RTC_bool = FALSE;
bool mode_bool[NB_MODE];
bool initmode_bool = TRUE;
bool TEST_bool = TRUE;
bool TEST_PASS = FALSE;


bool Function_bool = FALSE;
bool Wakeup_bool = FALSE;
bool KeyPressed = FALSE;


uint8_t LCD_String[7]= " STM8L ";
u16 ADC_ConvResult = 0;
u16 Vrefint = 0;
float Halt_Conso = 0;
float Vdd = 0;
char a=0,b=0,c=0,d=0;
int Halt_Conso_nA=0;
int units=0, tens=0, hundreds=0, thousands=0;
int i = 0;


// Private function prototypes -----------------------------------------------
// Private functions ---------------------------------------------------------

/**
  * @brief Example main entry point.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  */
void main(void)
{

	// Configures the LCD GLASS relative GPIO port IOs and LCD peripheral
		
	// Configure the Wakeup button and Function button as input with interrupt  
	GPIO_Init(BUTTON_GPIO_PORT, FUNCTION_GPIO_PIN, GPIO_Mode_In_FL_IT);
	GPIO_Init(BUTTON_GPIO_PORT, WAKEUP_GPIO_PIN, GPIO_Mode_In_FL_IT);
		
	// For consumption purpose configure pins not used by LCD in output 
	GPIO_Init(GPIOA, GPIO_Pin_0, GPIO_Mode_Out_PP_Low_Slow);
	GPIO_Init(GPIOA, GPIO_Pin_2, GPIO_Mode_Out_PP_High_Slow);
	#ifdef USE_LSE
	#else
		GPIO_Init(GPIOC, GPIO_Pin_5|GPIO_Pin_6,GPIO_Mode_Out_PP_Low_Slow);
	#endif
		
	
	LCD_GLASS_Init();
	
	LCD_GLASS_DisplayString("STM8L");



// Automatic test if FUNCTION is pressed at power on 
	if ((GPIOC->IDR & 0x01) == 0x0) 
	{
		while ((GPIOC->IDR & 0x01) == 0x0);
		delay_ms(200);
		LCD_Test();
		TEST_bool = TRUE;
		IDD_bool = TRUE;
		Wakeup_bool = FALSE;
		Function_bool = FALSE;
		KeyPressed = FALSE;
		delay_ms(100);
		enableInterrupts();	
		initmode_bool = TRUE;
		CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);
				
		while (Wakeup_bool == FALSE)		
		launch_mode(7);
		if (TEST_PASS == TRUE)
			LCD_GLASS_DisplayString("PASS");
		else
			LCD_GLASS_DisplayString("FAIL");
		halt();
	}
	
	delay_ms(200);	
	enableInterrupts();	
	

	IDD_question();

	RTC_question();
	if (RTC_bool == TRUE) 
		RTC_doInit();
		

	
	while(1)
	{
		
		Wakeup_bool = FALSE;
		Function_bool = FALSE;
		KeyPressed = FALSE;
		LPMode_Init();
		for (i = 1; i < NB_MODE; i++)
		{
			mode_question(i);
			if (mode_bool[i] == TRUE) 
			{
				CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);
				initmode_bool = TRUE;
				while (Wakeup_bool == FALSE)
				{
				  launch_mode(i);
				}
					
			}
			CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_16);
			Wakeup_bool = FALSE;
			Function_bool = FALSE;
			KeyPressed = FALSE;
			
		}
		
	}
	
}		
  		
	
 


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{
    /* User can add his own implementation to report the file name and line number,
       ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

    // Infinite loop 
    while (1)
    {
    }
}
#endif


