/**
  ******************************************************************************
  * @file    Project/Template/main.c
  * @author  MCD Application Team
  * @version V0.0.3
  * @date    07/21/2009
  * @brief   Main program body
  ******************************************************************************
  * @copy
  *
                         // System clock configuration                           *
  /* After each device reset the HSI/8 (~2MHz) is used as System clock source,
     to run at higher frequency you can change the System clock divider to 1 
     to get 16MHz ...*/
	//CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);
	
  // ... or/and you can use more precise clock (HSE) as System clock source **
  // Select HSE as system clock source 
  //CLK_SYSCLKSourceConfig(CLK_SYSCLKSource_HSE);
	// Enable Clock switch 
  //CLK_SYSCLKSourceSwitchCmd(ENABLE);
  // Wait till HSE is used as system clock source 
  //while (CLK_GetSYSCLKSource() != CLK_SYSCLKSource_HSE)
  //{}

     // Initialize LEDs and dot matrix LCD available on STM8L-EVAL board         *
  // Initialize LEDs available on STM8L-EVAL board 
  STM_EVAL_LEDInit(LED1);
  STM_EVAL_LEDInit(LED2);
  STM_EVAL_LEDInit(LED3);
  STM_EVAL_LEDInit(LED4);

  // Turn ON LED1..4 
  STM_EVAL_LEDOn(LED1);
  STM_EVAL_LEDOn(LED2);
  STM_EVAL_LEDOn(LED3);
  STM_EVAL_LEDOn(LED4);
	
  // Initialize dot matrix LCD available on STM8L-EVAL board 
	STM8L1526_LCD_Init();
	
	// Display message on LCD 
  LCD_PrintString(LCD_LINE1, DISABLE, DISABLE, MESSAGE1); 
  LCD_PrintString(LCD_LINE2, DISABLE, DISABLE, MESSAGE2);


  // Infinite loop 
  while (1)
  {
  }
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  // Infinite loop 
  while (1)
  {
  }
}
#endif

